"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.RealtimeListener = void 0;
var app_1 = require("firebase/app");
var database_1 = require("firebase/database");
var firebaseConfig = {
    databaseURL: "https://hacker-news.firebaseio.com"
};
var app;
try {
    app = app_1.initializeApp(firebaseConfig, "hacker-news-realtime-listener");
}
catch (e) {
    // Maybe we initialized Firebase twice, let's try to get the app
    app = app_1.getApp("hacker-news-realtime-listener");
    if (!app) {
        throw e;
    }
}
var db = database_1.getDatabase(app);
var RealtimeListener = /** @class */ (function () {
    function RealtimeListener(callback) {
        if (!callback) {
            throw new Error("Callback missing");
        }
        this._maxItemRef = database_1.ref(db, "/v0/maxitem");
        this._unsubscribeFunc = undefined;
        this.callback = callback;
    }
    RealtimeListener.prototype._maxItemUpdateHandler = function (snap) {
        return __awaiter(this, void 0, void 0, function () {
            var id, itemRef, itemSnap;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        id = snap.val();
                        itemRef = database_1.ref(db, "/v0/item/" + id);
                        return [4 /*yield*/, database_1.get(itemRef)];
                    case 1:
                        itemSnap = _a.sent();
                        if (itemSnap.val() == null) {
                            // Retry as Hacker News articles can take time to propagate
                            this._maxItemUpdateHandler(snap);
                            return [2 /*return*/];
                        }
                        this.callback(itemSnap.val());
                        return [2 /*return*/];
                }
            });
        });
    };
    RealtimeListener.prototype.start = function () {
        if (this._unsubscribeFunc) {
            throw new Error("Listener has already started");
        }
        this._unsubscribeFunc = database_1.onValue(this._maxItemRef, this._maxItemUpdateHandler.bind(this));
        return this;
    };
    RealtimeListener.prototype.stop = function () {
        if (!this._unsubscribeFunc) {
            throw new Error("RealtimeListener is not listening");
        }
        this._unsubscribeFunc();
        this._unsubscribeFunc = undefined;
    };
    return RealtimeListener;
}());
exports.RealtimeListener = RealtimeListener;
function listen(callback) {
    return new RealtimeListener(callback).start();
}
exports["default"] = listen;
if (typeof window != "undefined") {
    // @ts-ignore
    window.listen = listen;
    // @ts-ignore
    window.RealtimeListener = RealtimeListener;
}
